#!/usr/bin/env python
#coding=utf-8

import pygtk
pygtk.require('2.0')
import gtk.glade
import pango
import gobject
import string
from data import *
from comp import *


ICON=gtk.gdk.pixbuf_new_from_file("../ui/jquickmoney.png")
complist = gtk.ListStore(gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING,gobject.TYPE_STRING)
##auto-comp list(tag name,shortcut,count,sum)
def getcomplist():
    complist.clear()
    for item in DBFile.session.query(Tag).all():
        complist.append([item.name,item.shortcut,str(item.count),str(item.sum)])    

class UIInputBoxWind:
    def __init__(self):
        xml = self.xml = gtk.glade.XML('../ui/ui.glade', "InputBoxWind")
        xml.signal_autoconnect(self)
        win = self.win = xml.get_widget('InputBoxWind')
        win.icon=ICON
        self.imageclosed=xml.get_widget("ImageClosed")
        self.InputBox=xml.get_widget("InputBox")
        self.comp =Completion(self.InputBox,complist)
    def show(self):
        self.InputBox.set_text(u"现金")
        getcomplist()
        self.win.show()
    def hidewind(self):
        self.win.hide()
    def InputBoxHide(self,b="nil",c="nil",d="nil"):
        self.hidewind()
    def on_ImageClosed_button_press_event(self):
        self.hidewind()
    def kp(self, widget, event):
        if (event.keyval == gtk.keysyms.Escape):
            self.hidewind()
        if (event.keyval == gtk.keysyms.Tab):
                self.comp.comp.complete()
                return True
    def InputBoxenter(self,widget,event=None):
        str=self.InputBox.get_text()
        if str != "":
                quickinput(unicode(str))
        self.hidewind()

uiinputboxwind=UIInputBoxWind()

class UIDataEditWind:
    def __init__(self):
        self.xml=xml= gtk.glade.XML('../ui/ui.glade', domain = "DataEditWind")
        xml.signal_autoconnect(self)
        self.win=xml.get_widget("DataEditWind")
        self.win.set_icon(ICON)
        self.DataValue=xml.get_widget("DataValue")
        self.DataComment=xml.get_widget("DataComment")
        self.DataTag=xml.get_widget("DataTag")
        self.DataDate=xml.get_widget("DataDate")
        self.sb=xml.get_widget("DataEditWindSB")
    def edit_data(self,data=None):
        if data==None:
            data=Data(0,"","")
        self.data=data
        self.DataValue.set_text(str((data.value)/100.00))
        self.DataComment.get_buffer().set_text(data.comment)
        self.DataTag.set_text(data.get_tags().decode("UTF8"))
        self.DataDate.set_text(str(data.date))        
        self.sb.push(2,"Editing tag:{"+data.id+"}")    
        self.win.show()
    def edit_ok(self,w):
        value=self.DataValue.get_text()
        try: 
            self.data.value=float(value)*100
        except ValueError:
            self.sb.push(1,"Erroe:Value must be number")
            return
        self.data.comment=self.DataComment.get_buffer().get_text(self.DataComment.get_buffer().get_start_iter(),self.DataComment.get_buffer().get_end_iter())
        self.data.tags=unicode(self.DataTag.get_text())
        self.data.date=self.DataDate.get_text()        
        self.data.save()
        self.win.hide()
        uimainwind.TV_reflash()
    def edit_cancel(self,w):
        self.win.hide()
    def DEWclose(self,w,e):
        self.win.hide()
        return True
data_store=gtk.ListStore(gobject.TYPE_STRING,gobject.TYPE_STRING,gobject.TYPE_STRING, gobject.TYPE_PYOBJECT)
##{value,comment,date,data}
uidateedit=UIDataEditWind()



class UIQueryWind:
    def __init__ (self,db,domain):
        self.domain=domain
        xml = self.xml = gtk.glade.XML('../ui/ui.glade', domain = "QueryWind")
        xml.signal_autoconnect(self)
        self.win=xml.get_widget("QueryWind")
        self.win.set_icon(ICON)
## init treeview
        self.QueryTV=xml.get_widget("QueryTV")
        self.tvc_value=gtk.TreeViewColumn("金额")
        self.QueryTV.insert_column(self.tvc_value,-1)
        self.tvc_date=gtk.TreeViewColumn("日期")
        self.QueryTV.insert_column(self.tvc_date,-1)
        self.tvc_comment=gtk.TreeViewColumn("注释")
        self.QueryTV.insert_column(self.tvc_comment,-1)
        CR=self.CR=gtk.CellRendererText()
        self.TVReflash()
        self.tvc_value.pack_start(self.CR,False) 
        self.tvc_value.add_attribute(self.CR, "text",0)
        self.tvc_comment.pack_start(self.CR,False) 
        self.tvc_comment.add_attribute(self.CR, "text",1)
        self.tvc_date.pack_start(self.CR,False) 
        self.tvc_date.add_attribute(self.CR, "text",2)
        self.TVReflash()
        ##
        self.QueryInput=xml.get_widget("QueryInput")
        self.comp =Completion(self.QueryInput,complist)
        self.QWStatusbar=xml.get_widget("QWStatusbar")
    def query_edit_data(self, path, view_column,ud=None):
        selected=self.QueryTV.get_selection()
        if selected.count_selected_rows()==1:
            iter= selected.get_selected()[1]
            uidateedit.edit_data( data_store.get_value(iter,3))
    def QueryButton(self, a,b=None,c=None):
        self.Query(unicode(self.QueryInput.get_text()))
    def TVReflash(self):
        self.QueryTV.set_model(data_store)
    def Query(self,tags):
        self.QueryTV.set_model()
        data_store.clear()
        Q=DBFile.query_tags(tags)
        datas=Q.all()
        if datas==[]:
            self.QWStatusbar.push(1,"没有符合条件的记录")
        else:
            self.QWStatusbar.push(1,"共计："+str(Q.sum(Data.value)/100.00))
        for item in datas:
            data_store.append([str((item.value)/100.00),item.comment,item.date,item])
        self.TVReflash()
    def QWclose(self,w,e):
        self.win.hide()
        return True
    def show(self,str=""):
        getcomplist()
        self.QWStatusbar.push(1,"")
        if str != "":
            self.Query(str)
        else:
            data_store.clear()
        self.QueryInput.set_text(str.decode("UTF8"))
        self.win.show()
uiquerywind=UIQueryWind("","QueryWind")

maintag_store=gtk.ListStore(gobject.TYPE_STRING,gobject.TYPE_INT,gobject.TYPE_STRING,gobject.TYPE_STRING, gobject.TYPE_PYOBJECT)
## mainwind treevier(tag,count,sum,shortcut,Tag)

class UIMainWind:
    def __init__(self,):
        xml = self.xml = gtk.glade.XML('../ui/ui.glade', domain = "JQuickMoney")
        xml.signal_autoconnect(self)
        self.win=xml.get_widget("MainWind")
        self.win.connect("delete_event",self.MWclose)
        self.win.set_icon(ICON)
        ##init tag TreeView
        self.MainTV=xml.get_widget("MainTV")
        self.tvc_tag=gtk.TreeViewColumn("标签")
        self.MainTV.insert_column(self.tvc_tag,-1)
        self.tvc_count=gtk.TreeViewColumn("子条目个数")
        self.MainTV.insert_column(self.tvc_count,-1)        
        self.tvc_sum=gtk.TreeViewColumn("金额总计")
        self.MainTV.insert_column(self.tvc_sum,-1)
        self.tvc_shortcut=gtk.TreeViewColumn("首字母输入")
        self.MainTV.insert_column(self.tvc_shortcut,-1)
        CR=self.CR=gtk.CellRendererText()
        self.tvc_tag.pack_start(self.CR,False) 
        self.tvc_count.pack_start(self.CR,False) 
        self.tvc_sum.pack_start(self.CR,False)        
        self.tvc_shortcut.pack_start(self.CR,False)       
        self.tvc_tag.add_attribute(self.CR, "text",0)
        self.tvc_count.add_attribute(self.CR, "text",1)
        self.tvc_sum.add_attribute(self.CR, "text",2)        
        self.tvc_shortcut.add_attribute(self.CR, "text",3) 
        self.TV_reflash()
    def TV_reflash(self):
        self.MainTV.set_model()
        tags=DBFile.session.query(Tag).all()
        maintag_store.clear()
        for item in tags:
            maintag_store.append([item.name,item.count,str(item.sum/100.00),item.shortcut,item])
        self.MainTV.set_model(maintag_store)
    def TBQuery(self,w,e=None,U=None):
        uiquerywind.show()
    def show(self):
        self.TV_reflash()
        self.win.show()
    def MWclose(self,w,e):
        self.win.hide()
        return True
    def MVQueryTag(self, path, view_column,ud=None):
        selected=self.MainTV.get_selection()
        iter= selected.get_selected()[1]
        uiquerywind.show(unicode(maintag_store.get_value(iter,0)))
    def MainAdd(self,a="",b="",c=""):
        data=Data(0,"")
        uidateedit.edit_data(data)
    def MainQuit(self,a="",b="",c=""):
        gtk.main_quit()
uimainwind=UIMainWind()


class SysTrayIcon:
    def __init__(self):
        icon=self.statusicon= gtk.status_icon_new_from_pixbuf(ICON)
        self.statusicon.connect("activate",self.leftclick)
        self.statusicon.connect("popup-menu",self.rightclick)
    def leftclick(self,icon):
        uiinputboxwind.show()
    def rightclick(self,icon,button,time):
        if button==3:
            uimainwind.show()
systrayucon=SysTrayIcon()

def quickinput(str):
    str=" "+str+ " "
    re1=re.compile(" ([-－]?[\d]+([。.][\d]{0,2})?) ")
    re2=re1.search(str)
    if re2 !=None:
        value=re2.groups()[0]
        value=value.replace("－","-")
        value=value.replace( "。",".")
        value=string.atof(value)*100
        str=str[:re2.span()[0]]+str[(re2.span()[1]-1):]
        re1=re.compile(" ([(（](.*)[）)]) ")
        re2=re1.search(str)
        comment=""
        if re2 !=None:
            comment=re2.groups()[1]
            str=str[:re2.span()[0]]+str[re2.span()[1]-1:]
        re1=re.compile(" ([\d]{4,4}-[\d]{2,2}-[\d]{2,2}) ")
        re2=re1.search(str)
        ddate=""
        if re2 !=None:
            str=str[:re2.span()[0]]+str[re2.span()[1]-1:]
            try:
                dstr=re2.groups()[0]
                ddate=date(int(dstr[0:4]),int(dstr[5:7]),int(dstr[8:10]))
            except:
                ddate=""
        data=Data(value,comment,str,ddate)
        data.save()
        uimainwind.TV_reflash()
        return
    else :
        uiquerywind.show(str.strip())

if __name__ == '__main__':
    gtk.main()